
const complotDB = require('../database/ComplotDB.js');
const channelsID = require('../channels_conf.json');


class InformeMoi{
    constructor(client){
        this.client = client;
        this.channels = this.client.channels.cache;
        this.actorRE = new RegExp('<actor>', 'gi'); 
        this.wantRE = new RegExp('<want>', 'gi'); 
        this.reasonRE = new RegExp('<reason>', 'gi'); 
        this.sourceRE = new RegExp('<source>', 'gi'); 
        this.actionRE = new RegExp('<action>', 'gi'); 
    }

    fillAllRandomObject(sentence, regularExpr, randomMethode){
        const matches = sentence.matchAll(regularExpr);
        let objectString = "";
        let newSentence = sentence;
        for(let match of matches){
            objectString = randomMethode();
            newSentence = newSentence.replace(match, objectString);
        }
        
        return newSentence;
    }

    getRandomSentenceFilled(sentence){
        sentence = this.fillAllRandomObject(sentence, this.actorRE, complotDB.getRandomActor.bind(complotDB));
        sentence = this.fillAllRandomObject(sentence, this.actionRE, complotDB.getRandomAction.bind(complotDB));
        sentence = this.fillAllRandomObject(sentence, this.reasonRE, complotDB.getRandomReason.bind(complotDB));
        sentence = this.fillAllRandomObject(sentence, this.sourceRE, complotDB.getRandomSource.bind(complotDB));
        
        sentence = sentence.replaceAll(this.wantRE, 'veut'); /**Todo, change */
        return sentence;
    }

    getRandomComplot(){
        return this.getRandomSentenceFilled(complotDB.getRandomSentence());
    }

    getRandomWelcome(){
        return this.getRandomSentenceFilled(complotDB.getRandomWelcome());
    }

    sayWelcome(userID){
        let message = this.getRandomWelcome().replace('<new_user>', `<@${userID}>`);
        this.client.channels.cache.get(channelsID.welcome).send(message);
    }

    parse(message){
        if(this.shouldRespond(message)){
            message.reply(this.getRandomComplot());
        }
    }

    shouldRespond(message){    
        return message.content.toLowerCase().includes("informe moi");
    }
}

module.exports = InformeMoi;